/*!
 * @file weapon_power_up.h
 * @brief A class representing a PowerUp containing a weapon.
*/

#ifndef _WEAPON_POWER_UP_H
#define _WEAPON_POWER_UP_H

#include "power_up.h"
#include "weapons/weapon.h"
#include "weapons/weapon_manager.h"

/* FORWARD DEFINITION */

class WeaponPowerUp : public PowerUp {

public:
  WeaponPowerUp(const TiXmlElement* root = NULL);
  virtual ~WeaponPowerUp ();

  virtual void loadParams(const TiXmlElement* root);

  Weapon* getWeapon();
  void setWeaponClass(const std::string& name);

  virtual int writeBytes(const byte* data, int length, int sender);
  virtual int readBytes(byte* data, int maxLength, int * reciever );

  bool process(WeaponManager* manager);

private:
  void init();
  void newWeapon();
private:
  Weapon* weapon;
  const TiXmlElement* weaponXML;

  void createWeapon();
};

#endif /* _WEAPON_POWER_UP_H */
